#ifndef _QuaternionClass_
#define _QuaternionClass_

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>

#include "vector.h"
#include "matrix.h"

class Quaternion 
{
public:
	union
	{
		struct
		{
			float x,y,z,w;
		};
		struct 
		{ 
			Vector	Axis;
			float	Angle;
		};
	};

public:
	Quaternion(float a, float b, float c, float d) 
	{
		x=a; y=b; z=c; w=d;
	}
	Quaternion() {};
	void printf() const;
	void Convert(float a,Vector &v);
	float Norm();
	float Length();
	void Negate();
	void Invert();
	void Quaternion::Normalize();
	Matrix ConvertToMatrix();

	Quaternion operator-();
	Quaternion operator-(const Quaternion &b);
	Quaternion operator+(const Quaternion &b);
	Quaternion operator%(const Quaternion &b);
	Quaternion operator*(const float f);
	float operator*(const Quaternion &b);
};

#endif